;File name Biblcd2.inc   philippe.loutrel@laposte.net
;;;;;;;;;;;;;;;;;;;;;;;;BIBLI DE GESTION DU LCD;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Il faut RB4 connect sur R/S (pin 4 du LCD) et RB3 sur Enable(pin 6 du LCD)
;RA0  RA3 sur les lignes data (pin 11  14 du LCD)
;Variables: cs,inscar,Dfags,hex_H,hex_L,zc_H,zc_L,dixmil,mil,cent,dix,unit
;Exemples:
;	call	init_lcd	;une seule fois, en dbut de programme
;	mowlw	'A'
;	call	envcar		;affiche A en ligne 1, colonne 1
;	movlw	' '		
;	call	envcar		;affiche un espace  la suite de A

;	movlw	h'C2'		;voir la carte memoire ci-dessous
;	call	envins		;curseur (invisible) en li 2, col 3
;	movlw	'/'		;affiche un slash en li 2, col 3
;	call	envcar

;	movlw	d'1'		;admettons que hex=d'258',donc hex_H=1
;	movwf	hex_H
;	movlw	d'2'		;et hex_L=2
;	movwf	hex_L		
;	call	hex to_ascii	;decompose en cent=h'32',dix=h'35,unit=h'38'
				;pour pouvoir afficher "258" sur le LCD
;	movfw	cent
;	call	envcar		;affiche le chiffre 2
;	movfw	dix
;	call	envcar		;affiche ensuite le chiffre 5
;	etc

;	movfw	toto		;pour debugger un programme, affichage de w
;				;si toto= d'178'
;	call	aff_wcls	;on voit "178" en debut de LCD
;	movfw	titi		;si titi= d'125' l'affichage est maintenant
;	call	aff_w		;"178-125"		

;	call	cls		;raz du LCD

;			Carte Memoire DDRAM du LCD  

;		*************************************************
;		*                                               *
;		*80 81 82 83 84 85 86 87 88 89 8A 8B 8C 8D 8E 8F*
;		*                                               *
;		*************************************************
;		*						*                                     
;		*C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 CA CB CC CD CE CF*
;		*						*
;		************************************************* 

; Exemple: pour ecrire "%" en ligne 1 colonne 15
;	movlw	h'8E'
;	call	envins		;positionne le curseur invisible 
;	movlw	'%'
;	call	envcar		;affiche ce symbol en li 1, col 15
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INIT_LCD			;SUB d'initialisation pour LCD
	movlw	3
	movwf	cs		;on va repeter 3 fois cette sequence de mode 8 fils
et1	movlw	3		;
	movwf	PORTA		;3 est l'instruction pour 8 fils
	bsf	PORTB,3		;Enable on
	bcf	PORTB,3		;off
	call	Wait_1ms	;attente 5ms
	call	Wait_1ms
	call	Wait_1ms
	call	Wait_1ms
	call	Wait_1ms
	decfsz	cs,f
	goto	et1
	movlw	2		;instruction pour mode 4 fils
	movwf	PORTA
	bsf	PORTB,3		;Enable on

	bcf	PORTB,3
	call	Wait_1ms
	movlw	h'28'		;28= 4fils,2 lignes de texte,5X7
				;2A= 4fils,2 lignes de texte,5X10 
	movwf	inscar
	call	envins		;envoyer cette instruction
	movlw	h'0C'		;Aff visible, curseur invisible
	movwf	inscar
	call	envins
	movlw	6		;curseur vers la droite,sans deplact de texte
	movwf	inscar
	call	envins
	movlw	1		;CLS
	call	envins
	movlw	2		;cursor home= li 1 ,col 1  IMPORTANT!!
	call	envins
	return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AFF_wcls		;SUB  Efface le LCD puis affiche w en li 1, col 1
	movwf	CS
	call	cls
	movfw Cs

AFF_w			;SUB sans effacer l'cran, affiche w  la suite

	clrf	hex_H	;w tj <=255	
 	movwf	hex_L 	

 	call	hex_to_ascii	;dcompose en cent,dix et unit
  	movfw	cent		;afficher le resultat
 	call	envcar
 	movfw	dix
 	call	envcar
 	movfw	unit
 	call	envcar

	movlw	'-'
	call	envcar	;separateur pour le prochain w
 	return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CLS				;SUB d'effacement de l'ecran
	movlw	1		;fill with spaces
	call	envins
	movlw	2
	call	envins		;cursor home IMPORTANT pour premier adressage
	return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EFF_car				;SUB efface  la position du curseur( dans w)
	call	envins
	movlw	' '		;ASCII pour un espace
	call	envcar
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ENVINS				;SUB envoi d'une INSTRUCTION(commande) au LCD
	bcf	PORTB,4		;R/S = 0 pour le mode instruction
	goto	$+2
ENVCAR				;SUB envoi d'un CARACTERE  afficher au LCD
	bsf	PORTB,4		;R/S = 1 pour le mode affichage


ENV_8bit
	movwf	inscar		;SUB envoi de 8 bits sur 4 fils du LCD
	swapf	inscar,w	;d'abord les 4 bits de poids fort
	andlw	h'0F'
	movwf	PORTA
	bsf	PORTB,3		;Enable on
	bcf	PORTB,3		;off
	movfw	inscar		;puis les 4 bits de poids faible
	andlw	h'0F'
	movwf	PORTA
	bsf	PORTB,3		;Enable on
	bcf	PORTB,3		;off
	call	Wait_1ms
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HEX_to_ASCII			;SUB de conversion 0 - 65535 en ASCII
	movlw	h'30'		;Entre: HEX_H et _L la valeur  convertir
				;Sortie: Dixmil, mil,cent,dix,unit:code ASCII		
	movwf	dixmil		; 0 en ASCII= h'30', 5 = h'35' etc
	movwf	mil
	movwf	cent
	movwf	dix

	movlw	h'D8'		;-10 000
	movwf	zc_H
	movlw	h'F0'
	movwf	zc_L		;soustraire 10 000
	call	daddk		;hex + zc -> hex
	btfss	STATUS,C
	goto	$+3
	incf	dixmil,f
	goto	$-4

	movlw	h'27'		;+10 000, compense une soustraction en trop
	movwf	zc_H
	movlw	h'10'
	movwf	zc_L
	call	daddk

	movlw	h'FC'		;-1000
	movwf	zc_H
	movlw	h'18'
	movwf	zc_L		;soustraire 1000
	call	daddk		;hex + zc -> hex
	btfss	STATUS,C
	goto	$+3
	incf	mil,f
	goto	$-4

	movlw	h'3'		;+1000,compense
	movwf	zc_H
	movlw	h'E8'
	movwf	zc_L
	call	daddk

	movlw	h'FF'		;-100
	movwf	zc_H
	movlw	h'9C'
	movwf	zc_L		;soustraire 100
	call	daddk		;hex + zc -> hex
	btfss	STATUS,C
	goto	$+3
	incf	cent,f
	goto	$-4

	clrf	zc_H
	movlw	h'64'		;+100,compense
	movwf	zc_L
	call	daddk

	movlw	h'FF'		;-10 
	movwf	zc_H
	movlw	h'F6'
	movwf	zc_L		;soustraire 10 
	call	daddk		;hex + zc -> hex
	btfss	STATUS,C
	goto	$+3
	incf	dix,f
	goto	$-4
	clrf	zc_H
	movlw	h'0A'		;+10,compense
	movwf	zc_L
	call	daddk
	movfw	HEX_L		;il reste les units ds hex_L
	addlw	h'30'		; + h'30' pour ASCII 
	movwf	unit

	movfw	dixmil		;Sequences de test des leading zeroes
	addlw	-h'30'		;leading 0 ?
	btfss	STATUS,Z
	return
	bcf	dixmil,4	; cad  h'20' = espace
	movfw	mil
	addlw	-h'30'
	btfss	STATUS,Z
	return
	bcf	mil,4		; passe de h'30'  h'20' = espace
	movfw	cent
	addlw	-h'30'
	btfss	STATUS,Z
	return
	bcf	cent,4		; cad  h'20' = espace
	movfw	dix
	addlw	-h'30'
	btfsc	STATUS,Z
	bcf	dix,4		; cad  h'20' = espace
	return

daddk				;SUB add, double precision, (cte ZC + hex) =>hex
	bcf	Dflags,0	;flag de carry sortant des 16 bits
	movfw	zc_L
	addwf	hex_L,f
	movlw	1
	btfsc	STATUS,C
	addwf	hex_h,f		
	btfsc	STATUS,C	;dj C=1 ?
	bsf	Dflags,0	;oui,  memoriser pour la sortie
	movfw	zc_H
	addwf	hex_H,f		;sets C mais si 
	btfsc	Dflags,0	;l'ancien C etait 1, 
	bsf	STATUS,C	;alors forcer C=1
	return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_1ms			;SUB d'attente 1 ms
	movlw	d'250'		;attendre 1ms = 250X4mus
sd	addlw	-1		;                                                  1mus
	btfss	STATUS,Z	;                                                  1
	goto	sd		;                                                  2
	return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_wms			;SUB attente w ms 
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


